﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace XnaDevRu.Assets
{
	class AssetBinaryReader : AssetAccessor
	{
		private BinaryReader _reader;

		public AssetBinaryReader(BinaryReader reader, AssetLibrary lib):base(lib)
		{
			_reader = reader;
		}

		public override void Visit(ref byte byteData, string filedName)
		{
			BeginField(filedName);

			byteData = _reader.ReadByte();

			EndField(filedName);
		}

		public override void Visit(ref short shortData, string filedName)
		{
			BeginField(filedName);

			shortData = _reader.ReadInt16();

			EndField(filedName);
		}

		public override void Visit(ref int intData, string filedName)
		{
			BeginField(filedName);

			intData = _reader.ReadInt32();

			EndField(filedName);
		}

		public override void Visit(ref float floatData, string filedName)
		{
			BeginField(filedName);

			floatData = _reader.ReadSingle();

			EndField(filedName);
		}

		public override void Visit(ref long longData, string filedName)
		{
			BeginField(filedName);

			longData = _reader.ReadInt64();

			EndField(filedName);
		}

		public override void Visit(ref string txtData, string filedName)
		{
			BeginField(filedName);

			txtData = _reader.ReadString();

			EndField(filedName);
		}
	}
}
