﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;


namespace XnaDevRu.Assets
{
	class AssetBinaryWriter : AssetAccessor
	{
		BinaryWriter _writer;

		public AssetBinaryWriter(BinaryWriter writer, AssetLibrary lib):base(lib)
		{
			_writer = writer;
		}

		public override void Visit(ref byte byteData, string filedName)
		{
			BeginField(filedName);

			_writer.Write(byteData);

			EndField(filedName);
		}

		public override void Visit(ref short shortData, string filedName)
		{
			BeginField(filedName);

			_writer.Write(shortData);

			EndField(filedName);
		}

		public override void Visit(ref int intData, string filedName)
		{
			BeginField(filedName);

			_writer.Write(intData);

			EndField(filedName);
		}

		public override void Visit(ref float floatData, string filedName)
		{
			BeginField(filedName);

			_writer.Write(floatData);

			EndField(filedName);
		}

		public override void Visit(ref long longData, string filedName)
		{
			BeginField(filedName);

			_writer.Write(longData);

			EndField(filedName);
		}


		public override void Visit(ref string txtData, string filedName)
		{
			BeginField(filedName);

			if(txtData == null)
				_writer.Write(string.Empty);
			else
			_writer.Write(txtData);

			EndField(filedName);
		}
	}
}
