﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace XnaDevRu.Assets
{
	/// <summary>
	/// Array helper
	/// </summary>
	/// <remarks>
	/// This struct is only for fields.
	/// Do not use this struct as properties values or as method arguments
	/// </remarks>
	/// <typeparam name="T"></typeparam>
	public struct DataList<T>
	{
		public readonly static int ElementSise;

		static DataList()
		{
			if (typeof(T).IsValueType)
				DataList<T>.ElementSise = Marshal.SizeOf(typeof(T));
			else
				DataList<T>.ElementSise = 4;

		}

		public T[] Array;

		public DataList(T[] arr)
		{
			Array = arr;
		}

		internal void Add(T item)
		{
			if(Array == null)
			{
				Array = new T[1];
				Array[0] = item;

				return;
			}

			T[] newArray = new T[Array.Length + 1];

			// works for any T type
			Array.CopyTo(newArray, 0);

			// it is faster but it does not work if T is reference type...
			//Buffer.BlockCopy(Array, 0, newArray, 0, ArrayList<T>.ElementSise * Array.Length);

			newArray[Array.Length] = item;

			Array = newArray;
		}

		public int Count
		{
			get
			{
				if (Array == null)
					return 0;

				return Array.Length;
			}
		}

		public override string ToString()
		{
			return "Array of " + typeof(T).Name + ", Length = " + Count;
		}
	}
}
