﻿using System;
using System.Collections.Generic;
using System.Text;

namespace XnaDevRu.Assets
{
	public interface IAssetExporter
	{
		/// <summary>
		/// Saves asset to custom data format
		/// </summary>
		/// <typeparam name="T"></typeparam>
		/// <param name="asset"></param>
		/// <param name="file"></param>
		void Save<T>(T asset, string file) where T : Asset, new();

		void ResetExporter();

		string FileExtension { get; }

		AssetLibrary Library { get; set; }


	}
}
