//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// DarkSky
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Terrain
//--------------------------------------------------------------//
string Atmospheric_Effects_DarkSky_Terrain_Terrain : ModelData = "../../../../Program Files/ATI Research Inc/RenderMonkey 1.6/Examples/Media/Models/Terrain.3ds";

float4x4 view_proj_matrix : ViewProjection;
float4 lightPos
<
   string UIName = "lightPos";
   string UIWidget = "Direction";
   bool UIVisible = " false";
   float4 UIMin = ( -1200.00, -1200.00, -1200.00, -1200.00 );
   float4 UIMax = ( 1200.00, 1200.00, 1200.00, 1200.00 );
   bool Normalize = " false";
> = ( 1200.00, 0.00, 576.00, 1.00 );
float terrainZBias
<
   string UIName = "terrainZBias";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = -400.00;
   float UIMax = 400.00;
> = -200.00;
struct VS_OUTPUT {
   float4 Pos:      POSITION;
   float2 texCoord: TEXCOORD0;
   float3 normal:   TEXCOORD1;
   float3 lightVec: TEXCOORD2;
   float3 pos:      TEXCOORD3;
};

VS_OUTPUT Atmospheric_Effects_DarkSky_Terrain_Vertex_Shader_main(float4 Pos: POSITION, float2 texCoord: TEXCOORD0, float3 normal: NORMAL){
   VS_OUTPUT Out;

   // Translate
   Pos.z += terrainZBias;

   Out.Pos = mul(view_proj_matrix, Pos);
   Out.texCoord = texCoord;
   // World-space lighting
   Out.normal = normal;
   Out.lightVec = lightPos - Pos.xyz;
   // Pass position to the fragment shader
   Out.pos = Pos.xyz;

   return Out;
}



float skyZBias
<
   string UIName = "skyZBias";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = -800.00;
   float UIMax = 800.00;
> = -720.00;
float scale
<
   string UIName = "scale";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = 0.00;
   float UIMax = 0.01;
> = 0.00;
float cloudSpeed
<
   string UIName = "cloudSpeed";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = 0.00;
   float UIMax = 0.20;
> = 0.10;
float noiseSpeed
<
   string UIName = "noiseSpeed";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = 0.00;
   float UIMax = 0.10;
> = 0.03;
float time_0_X : Time0_X;
float noiseScale
<
   string UIName = "noiseScale";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = -10.00;
   float UIMax = 10.00;
> = 6.20;
float noiseBias
<
   string UIName = "noiseBias";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = -10.00;
   float UIMax = 10.00;
> = -3.00;
float4 Atmospheric_Effects_DarkSky_Terrain_Pixel_Shader_lightPos
<
   string UIName = "Atmospheric_Effects_DarkSky_Terrain_Pixel_Shader_lightPos";
   string UIWidget = "Direction";
   bool UIVisible = " false";
   float4 UIMin = ( -1200.00, -1200.00, -1200.00, -1200.00 );
   float4 UIMax = ( 1200.00, 1200.00, 1200.00, 1200.00 );
   bool Normalize = " false";
> = ( 1200.00, 0.00, 576.00, 1.00 );
float skyScale
<
   string UIName = "skyScale";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = 0.00;
   float UIMax = 1200.00;
> = 996.00;
texture Noise_Tex
<
   string ResourceName = "..\..\..\..\Program Files\ATI Research Inc\RenderMonkey 1.6\Examples\Media\Textures\NoiseVolume.dds";
>;
sampler Noise = sampler_state
{
   Texture = (Noise_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   ADDRESSW = WRAP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
texture Terrain_Tex
<
   string ResourceName = "..\..\..\..\Program Files\ATI Research Inc\RenderMonkey 1.6\Examples\Media\Textures\Terrain.tga";
>;
sampler Terrain = sampler_state
{
   Texture = (Terrain_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
float4 Atmospheric_Effects_DarkSky_Terrain_Pixel_Shader_main(float2 texCoord: TEXCOORD0, float3 normal: TEXCOORD1, float3 lightVec: TEXCOORD2, float3 pos: TEXCOORD3) : COLOR {
   // Center of the sky sphere
   float3 center = float3(0, 0, skyZBias);

   float3 v = Atmospheric_Effects_DarkSky_Terrain_Pixel_Shader_lightPos - pos;
   float t = dot(v, center - pos) / dot(v, v);
   // The point along the line to the moon perpendicular
   // to the center of the sky sphere
   float3 perp = pos + t * v;

   float l = perp - center;
   float x = sqrt(skyScale * skyScale - dot(l, l));

   // The point in sky the line from the moon down to
   // this pixel hits the sky sphere
   float3 skyPos = perp + x * normalize(v);

   // Create cloud like we'd do for the sky at that position
   skyPos *= scale;   
   skyPos.xy += cloudSpeed * time_0_X;
   skyPos.z  += noiseSpeed * time_0_X;
   float noisy = tex3D(Noise, skyPos);
   float lrp = noiseScale * noisy + noiseBias;

   // Define the shadow from the cloud
   float shadow = saturate(1 - lrp);

   // Apply some simple lighting
   float4 base = tex2D(Terrain, texCoord);
   float3 lVec = normalize(lightVec);
   float diffuse = dot(lVec, normal);

   return diffuse * base * shadow + 0.25 * base;
}


//--------------------------------------------------------------//
// Moon
//--------------------------------------------------------------//
string Atmospheric_Effects_DarkSky_Moon_Sky_Sphere : ModelData = "../../../../Program Files/ATI Research Inc/RenderMonkey 1.6/Examples/Media/Models/Sphere.3ds";

float4x4 Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_view_proj_matrix : ViewProjection;
float4 Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_lightPos
<
   string UIName = "Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_lightPos";
   string UIWidget = "Direction";
   bool UIVisible = " false";
   float4 UIMin = ( -1200.00, -1200.00, -1200.00, -1200.00 );
   float4 UIMax = ( 1200.00, 1200.00, 1200.00, 1200.00 );
   bool Normalize = " false";
> = ( 1200.00, 0.00, 576.00, 1.00 );
struct Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_VS_OUTPUT {
   float4 Pos: POSITION;
};

Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_VS_OUTPUT Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_main(float4 Pos: POSITION){
   Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_VS_OUTPUT Out;

   // Get the moon in place
   Pos.xyz += Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_lightPos;

   Out.Pos = mul(Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_view_proj_matrix, Pos);

   return Out;
}




float4 moonColor
<
   string UIName = "moonColor";
   string UIWidget = "ColorPicker";
   bool UIVisible = " true";
> = ( 1.00, 0.96, 0.73, 1.00 );
float4 Atmospheric_Effects_DarkSky_Moon_Pixel_Shader_main() : COLOR {
   return moonColor;
}


//--------------------------------------------------------------//
// Sky
//--------------------------------------------------------------//
string Atmospheric_Effects_DarkSky_Sky_Sky_Sphere : ModelData = "../../../../Program Files/ATI Research Inc/RenderMonkey 1.6/Examples/Media/Models/Sphere.3ds";

float4x4 Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_view_proj_matrix : ViewProjection;
float Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_skyScale
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_skyScale";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = 0.00;
   float UIMax = 1200.00;
> = 996.00;
float Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_skyZBias
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_skyZBias";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = -800.00;
   float UIMax = 800.00;
> = -720.00;
struct Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_VS_OUTPUT {
   float4 Pos: POSITION;
   float3 texCoord: TEXCOORD0;
};

Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_VS_OUTPUT Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_main(float4 Pos: POSITION){
   Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_VS_OUTPUT Out;

   // Get the sky in place
   Pos.xyz = Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_skyScale * normalize(Pos.xyz);
   Pos.y += Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_skyZBias;

   Out.Pos = mul(Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_view_proj_matrix, Pos);
   // Pass the position to the fragment shader
   Out.texCoord = Pos.xyz;

   return Out;
}







float Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseSpeed
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseSpeed";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = 0.00;
   float UIMax = 0.10;
> = 0.03;
float Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_time_0_X : Time0_X;
float Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseScale
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseScale";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = -10.00;
   float UIMax = 10.00;
> = 6.20;
float Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseBias
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseBias";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = -10.00;
   float UIMax = 10.00;
> = -3.00;
float4 cloudColor
<
   string UIName = "cloudColor";
   string UIWidget = "ColorPicker";
   bool UIVisible = " true";
> = ( 0.20, 0.40, 1.00, 1.00 );
float Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_scale
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_scale";
   string UIWidget = "Numeric";
   bool UIVisible = " false";
   float UIMin = 0.00;
   float UIMax = 0.01;
> = 0.00;
float Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_cloudSpeed
<
   string UIName = "Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_cloudSpeed";
   string UIWidget = "Numeric";
   bool UIVisible = " true";
   float UIMin = 0.00;
   float UIMax = 0.20;
> = 0.10;
sampler Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_Noise = sampler_state
{
   Texture = (Noise_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   ADDRESSW = WRAP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
float4 Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_main(float3 texCoord: TEXCOORD0) : COLOR {
   // Create a cloud effect. Clouds are basically noise,
   // we just need to Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_scale and bias it.
   texCoord *= Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_scale;
   texCoord.xy += Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_cloudSpeed * Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_time_0_X;
   texCoord.z  += Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseSpeed * Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_time_0_X;
   float noisy = tex3D(Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_Noise, texCoord);

   float lrp = Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseScale * noisy + Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_noiseBias;

   return float4(cloudColor.xyz, lrp);
}






//--------------------------------------------------------------//
// Technique Section for Effect Workspace.Atmospheric Effects.DarkSky
//--------------------------------------------------------------//
technique DarkSky
{
   pass Terrain
   {
      CULLMODE = CCW;
      ALPHABLENDENABLE = FALSE;

      VertexShader = compile vs_1_1 Atmospheric_Effects_DarkSky_Terrain_Vertex_Shader_main();
      PixelShader = compile ps_2_0 Atmospheric_Effects_DarkSky_Terrain_Pixel_Shader_main();
   }

   pass Moon
   {
      VertexShader = compile vs_1_1 Atmospheric_Effects_DarkSky_Moon_Vertex_Shader_main();
      PixelShader = compile ps_1_1 Atmospheric_Effects_DarkSky_Moon_Pixel_Shader_main();
   }

   pass Sky
   {
      ZWRITEENABLE = TRUE;
      SRCBLEND = SRCALPHA;
      DESTBLEND = INVSRCALPHA;
      CULLMODE = CW;
      ALPHABLENDENABLE = TRUE;

      VertexShader = compile vs_1_1 Atmospheric_Effects_DarkSky_Sky_Vertex_Shader_main();
      PixelShader = compile ps_2_0 Atmospheric_Effects_DarkSky_Sky_Pixel_Shader_main();
   }

}

