// Created by Phill Q <inpherno@gmail.com>

float4x4 worldViewProj : WORLDVIEWPROJ; // Our world view projection matrix

// Application to vertex structure
struct a2v
{
    float4 position : POSITION0;
    float4 color : COLOR0;
};

// Vertex to pixel shader structure
struct v2p
{
    float4 position : POSITION0;
    float4 color : COLOR0;
};

// Pixel shader to screen
struct p2f
{
    float4 color : COLOR0;
};

// VERTEX SHADER
void vs(in a2v IN, out v2p OUT)
{
    OUT.position = mul(IN.position, worldViewProj);
    OUT.color = IN.color;
}

// PIXEL SHADER
void ps(in v2p IN, out p2f OUT)
{
    // Make the colour increase and decrease in brightness in a wave
    // Decrease 5.0f to extend the range of brightness
    float4 mycolor = IN.color;
    
	// Clip the color between 0 and 1
    OUT.color = clamp(mycolor, 0, 1);
}

technique simple
{
    pass p0
    {
        vertexshader = compile vs_1_1 vs();
        // use of sin() in ps requires ps2.0
        pixelshader = compile ps_1_1 ps();
    }
}
