using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace XnaDevRu.Physics
{
    /// <summary>
    /// A data structure describing a box Shape.
    /// </summary>
    public class BoxShapeData : ShapeData
    {
        /// <summary>
        /// The box's dimensions.
        /// </summary>
        public Vector3 Dimensions;

        public BoxShapeData()
		{
			shapeType =  ShapeType.Box;
			Dimensions = Defaults.Shape.BoxDimensions;
		}

		public override BoundingBox LocalAABB
		{
            get
            {
                BoundingBox bbox = new BoundingBox();

                bbox.Min.X = -0.5f * Dimensions.X;
                bbox.Max.X = 0.5f * Dimensions.X;
                bbox.Min.Y = -0.5f * Dimensions.Y;
                bbox.Max.Y = 0.5f * Dimensions.Y;
                bbox.Min.Z = -0.5f * Dimensions.Z;
                bbox.Max.Z = 0.5f * Dimensions.Z;

                return bbox;
            }
		}
    }
}
